/**************************************************************************/
/*                                                                        */
/* Copyright (c) 2001,2003 NoMachine, http://www.nomachine.com.           */
/*                                                                        */
/* NXPROXY, NX protocol compression and NX extensions to this software    */
/* are copyright of NoMachine. Redistribution and use of the present      */
/* software is allowed according to terms specified in the file LICENSE   */
/* which comes in the source distribution.                                */
/*                                                                        */
/* Check http://www.nomachine.com/licensing.html for applicability.       */
/*                                                                        */
/* NX and NoMachine are trademarks of Medialogic S.p.A.                   */
/*                                                                        */
/* All rights reserved.                                                   */
/*                                                                        */
/**************************************************************************/

#include "OpcodeStore.h"

OpcodeStore::OpcodeStore()
{
  //
  // Assign opcodes according to NX protocol.
  //

  getControlParameters = X_NXGetControlParameters;
  getCleanupParameters = X_NXGetCleanupParameters;
  getImageParameters   = X_NXGetImageParameters;
  getUnpackParameters  = X_NXGetUnpackParameters;

  startSplit      = X_NXStartSplit;
  endSplit        = X_NXEndSplit;
  split           = X_NXSplit;
  commitSplit     = X_NXCommitSplit;
  abortSplit      = X_NXAbortSplit;
  sync            = X_NXSync;
  karma           = X_NXKarma;
  setExposeEvents = X_NXSetExposeEvents;

  setUnpackGeometry = X_NXSetUnpackGeometry;
  setUnpackColormap = X_NXSetUnpackColormap;
  putPackedImage    = X_NXPutPackedImage;

  splitNotify = NXSplitNotify;
  syncNotify  = NXSyncNotify;
  karmaNotify = NXKarmaNotify;

  //
  // These must be fetched from X server.
  //

  shapeExtension  = 0;
  renderExtension = 0;
}

OpcodeStore::~OpcodeStore()
{
}
