/**************************************************************************/
/*                                                                        */
/* Copyright (c) 2001,2003 NoMachine, http://www.nomachine.com.           */
/*                                                                        */
/* NXPROXY, NX protocol compression and NX extensions to this software    */
/* are copyright of NoMachine. Redistribution and use of the present      */
/* software is allowed according to terms specified in the file LICENSE   */
/* which comes in the source distribution.                                */
/*                                                                        */
/* Check http://www.nomachine.com/licensing.html for applicability.       */
/*                                                                        */
/* NX and NoMachine are trademarks of Medialogic S.p.A.                   */
/*                                                                        */
/* All rights reserved.                                                   */
/*                                                                        */
/**************************************************************************/

#ifndef SequenceQueue_H
#define SequenceQueue_H

//
// List of outstanding request messages, used to correlate
// request sequence numbers to their message types.
//

class SequenceQueue
{
  public:

  SequenceQueue();

  virtual ~SequenceQueue();

  void push(unsigned short int sequenceNum, unsigned char requestOpcode,
                unsigned int data1 = 0, unsigned int data2 = 0, unsigned int data3 = 0);

  int peek(unsigned short int &sequenceNum, unsigned char &requestOpcode);

  int peek(unsigned short int &sequenceNum, unsigned char &requestOpcode,
               unsigned int &data1, unsigned int &data2, unsigned int &data3);

  int pop(unsigned short int &sequenceNum, unsigned char &requestOpcode, 
              unsigned int &data1, unsigned int &data2, unsigned int &data3);

  int pop(unsigned short int &sequenceNum, unsigned char &requestOpcode)
  {
    unsigned int data1, data2, data3;

    return pop(sequenceNum, requestOpcode, data1, data2, data3);
  }

  private:

  struct RequestSequenceNum
  {
    unsigned short int sequenceNum;
    unsigned char requestOpcode;
    unsigned int data1, data2, data3;
  };

  RequestSequenceNum *queue_;

  unsigned int size_;
  unsigned int length_;
  unsigned int startIndex_;
  unsigned int endIndex_;
};

#endif /* SequenceQueue_H */
